"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = fetchWithTimeout;
exports.injectFetchConfig = void 0;
var config = {
  timeout: 20000
};

var injectFetchConfig = function injectFetchConfig(cfg) {
  Object.assign(config, cfg);
};

exports.injectFetchConfig = injectFetchConfig;

function fetchWithTimeout(fetchPromise) {
  var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : config.timeout;
  var abortFn = null; //这是一个可以被reject的promise

  var abortPromise = new Promise(function (resolve, reject) {
    abortFn = function abortFn() {
      reject(new Error('fetch timeout'));
    };
  });
  var timeoutId = setTimeout(function () {
    abortFn();
  }, timeout); //这里使用Promise.race，以最快 resolve 或 reject 的结果来传入后续绑定的回调

  var abortablePromise = Promise.race([fetchPromise.then(function (data) {
    clearTimeout(timeoutId);
    return data;
  }), abortPromise]);
  return abortablePromise;
}